#ifndef PACKAGE__PROG__PRJLIBS__DIEWARN_H
#define PACKAGE__PROG__PRJLIBS__DIEWARN_H

#define DIE1X(status,x0)    strerr_die3x((status), PROG, ": ", (x0))
#define DIE2X(status,x0,x1) strerr_die4x((status), PROG, ": ", (x0), (x1))

#define DIE_OVERFLOW() DIE1X(100, "arithmetic overflow")
#define DIE_MALFORMED(x0) DIE2X(100, (x0), " malformed")

#define DIESTAT (error_temp(errno)? 111: 100)

#define WARNTEXT0_alloc       "allocate memory"
#define WARNTEXT0_gethostname "get hostname"
#define WARNTEXT0_prefeed     "prefeed buffer"
#define WARNTEXT1_mkdir       "create directory"
#define WARNTEXT1_stat        "stat"
#define WARNTEXT1_exec        "execute"
#define WARNTEXT1_unlink      "remove"
#define WARNTEXT1_open        "open"
#define WARNTEXT1_close       "close"
#define WARNTEXT1_read        "read"
#define WARNTEXT1_write       "write"
#define WARNTEXT2_link        "link"
#define WARNSEP2_link         " to "

#define WARNTEXT_unable(n, op) ": unable to " op
#define WARNTEXT0(op) WARNTEXT_unable(0, op) ": "
#define WARNTEXT1(op) WARNTEXT_unable(1, op) " "
#define WARNTEXT2(op) WARNTEXT_unable(2, op) " "

#define WARN0(op)       strerr_warn2sys(PROG, WARNTEXT0(WARNTEXT0_##op))
#define WARN1(op,x0)    strerr_warn4sys(PROG, WARNTEXT1(WARNTEXT1_##op), \
                                        (x0), ": ")
#define WARN2(op,x0,x1) strerr_warn6sys(PROG, WARNTEXT2(WARNTEXT2_##op), \
                                        (x0), WARNSEP2_##op, (x1), ": ")

#define DIE0(op)       strerr_die2sys(DIESTAT, PROG, WARNTEXT0(WARNTEXT0_##op))
#define DIE1(op,x0)    strerr_die4sys(DIESTAT, PROG, \
                                      WARNTEXT1(WARNTEXT1_##op), (x0), ": ")
#define DIE2(op,x0,x1) strerr_die6sys(DIESTAT, PROG, \
                                      WARNTEXT2(WARNTEXT2_##op), (x0),\
                                      WARNSEP2_##op, (x1), ": ")

#endif
